// 003 u_build_news_message_tree
// 13 dec 2006

// -- (C) Felix John COLIBRI 2006
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_build_news_message_tree;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    exit_: TButton;
    clear_: TButton;
    Panel4: TPanel;
    threads_: TButton;
    headers_: TButton;
    ListBox1: TListBox;
    tree_: TCheckBox;
    build_tree_: TCheckBox;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    display_: TTabSheet;
    Memo1: TMemo;
    original_: TTabSheet;
    original_memo_: TMemo;
    tree_view_: TTabSheet;
    Splitter2: TSplitter;
    thread_listbox_: TListBox;
    Panel5: TPanel;
    Splitter3: TSplitter;
    thread_treeview_: TTreeView;
    message_memo_: TMemo;
    broken_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure threads_Click(Sender: TObject);
    procedure broken_Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure thread_listbox_Click(Sender: TObject);
    procedure thread_treeview_Click(Sender: TObject);
    procedure headers_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_c_ini_file
      , u_characters, u_strings
      , u_c_news_thread_list
      ;

    {$R *.DFM}


    const k_initial_directory= 'c:\programs\us\web\nntp\_data\';
            k_extension= '.pas';
            k_file_name= 'pascal.pas';

          k_xxx_path_ini_key=   'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

        g_file_count: Integer= 0;

        g_c_news_thread_list: c_news_thread_list= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure fill_thread_listbox;
      var l_news_thread_index: Integer;
      begin
        with g_c_news_thread_list do
          for l_news_thread_index:= 0 to f_news_thread_count- 1 do
            with f_c_news_thread(l_news_thread_index) do
              Form1.thread_listbox_.Items.AddObject(m_name, f_c_self);
      end; // fill_thread_listbox

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;

        Inc(g_file_count);

        display('  '+ p_file_name);
(*
        if g_c_news_thread_list<> Nil
          then begin
              display_bug_stop('Free_not_implented. Restart');
            end;
*)
        g_c_news_thread_list.Free;    
        g_c_news_thread_list:= c_news_thread_list.create_news_thread_list('news_list');
        g_c_news_thread_list.m_do_build_tree:= Form1.build_tree_.Checked;
        g_c_news_thread_list.load_from_file(p_path+ p_file_name);

        Form1.original_memo_.Lines.LoadFromFile(p_path+ p_file_name);
        fill_thread_listbox;
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_initial_directory);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_file_name);
        end; // with g_c_ini_file

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1 do
          ItemIndex:= Items.IndexOf(g_file_name);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];

        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
      end; // FileListBox1Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure TForm1.threads_Click(Sender: TObject);
      begin
        if g_c_news_thread_list= Nil
          then Exit;

        g_c_news_thread_list.display_news_thread_list;
      end; // list_threads_Click

    procedure TForm1.broken_Click(Sender: TObject);
      begin
        if g_c_news_thread_list= Nil
          then Exit;

        // display_strings_only(g_c_news_thread_list.m_c_broken_news_thread_list.m_c_news_thread_list);
      end; // broken_Click

    procedure TForm1.ListBox1Click(Sender: TObject);
      begin
        if g_c_news_thread_list= Nil
          then Exit;

        with ListBox1 do
          g_c_news_thread_list.display_news_thread(Items[ItemIndex], tree_.Checked);
      end; // ListBox1Click

    procedure TForm1.thread_listbox_Click(Sender: TObject);
      var l_c_news_thread: c_news_thread;
      begin
        with thread_listbox_ do
          l_c_news_thread:= c_news_thread(Items.Objects[ItemIndex]);

        with l_c_news_thread do
        begin
          Caption:= m_name;
          if m_c_root_news_message<> Nil
            then l_c_news_thread.fill_treeview(thread_treeview_);
        end; // with l_c_news_thread
      end; // thread_listbox_Click

    procedure TForm1.thread_treeview_Click(Sender: TObject);
      var l_c_news_message: c_news_message;
      begin
        if g_c_news_thread_list= Nil
          then Exit;

        l_c_news_message:= c_news_message(thread_treeview_.Selected.Data);
        with message_memo_.Lines do
        begin
          Clear;
          if (l_c_news_message= Nil)
            then Add('nil')
            else begin
                with l_c_news_message do
                begin
                  Add(m_user_name);
                  Add(m_date);
                end
              end;
        end; // with message_memo_.Lines 
      end; // thread_treeview_Click

    procedure TForm1.headers_Click(Sender: TObject);
      var l_list_index: Integer;
          l_the_line: String;
          l_id, l_thread_title, l_name: String;
          l_display: String;
          l_index: Integer;
      begin
        if g_c_news_thread_list= Nil
          then Exit;

        with tStringList.Create do
        begin
          LoadFromFile(g_path+ g_file_name);
          display(IntTostr(Count));
          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Strings[l_list_index];
            l_index:= 1;
            l_id:= f_string_extract_non_blank(l_the_line, l_index);

            skip_blanks(l_the_line, l_index);
            l_thread_title:= Trim(f_string_extract_until(l_the_line, k_tabulation, l_index));
            l_thread_title:= Copy(l_thread_title, 1, 25);

            skip_blanks(l_the_line, l_index);
            l_name:= Trim(f_string_extract_until(l_the_line, '<', l_index));
            if l_name[1]= '"'
              then begin
                  l_index:= 2;
                  l_name:= f_string_extract_until(l_name, '"', l_index)+ '|';
                end;
            // display(l_id+ ' '+ Format('%-25s ', [l_thread_title])+ ' '+ l_name);
            if l_id> '26800'
              then begin
                  display(l_id+ ' '+ Format('%-25s ', [l_thread_title])+ ' '+ l_name);
                  // display(l_thread_title);
                  // display('  '+ l_id+ ' '+ l_name);
                end;

          end; // while l_list_index
          Free;
        end;
      end; // thread_and_message_Click

end.


