// 002 u_c_news_thread_list
// 13 dec 2006

// -- (C) Felix John COLIBRI 2006
// -- documentation: http://www.felix-colibri.com

// -- todo: free is not totally finished

(*$r+*)

unit u_c_news_thread_list;
  interface
    uses Classes
        , ComCtrls // tTreeView
        , u_c_basic_object
        , u_c_log
    ;

    type c_news_thread_list= Class; // forward
         c_news_message= // one "news_message"
                         Class(c_basic_object)
                           // -- m_name: the key (to find the children)
                           m_c_parent_news_thread_list: c_news_thread_list;

                           // -- the number "26.827"
                           m_id: String;
                           m_user_name_and_e_mail: String;
                           m_date: String;
                           // -- the NNTP key "<457a3fa6$1@newsgroups.borland.com>"
                           m_key: String;
                           m_byte_count: String;
                           m_line_count: String;
                           m_group_ref: String;

                           m_user_name, m_user_e_mail: String;

                           // -- 0 is m_key, 1 is the root, 2 the next, Count-1 the father
                           m_c_key_list: tStringList;

                           // -- "root"= m_c_key_list.Count= 1
                           m_is_first_in_thread: Boolean;

                           Constructor create_news_message(p_name: String;
                               p_c_parent_news_thread_list: c_news_thread_list);
                           function f_display_news_message: String;
                           function f_c_self: c_news_message;
                           Destructor Destroy; Override;
                         end; // c_news_message

         c_news_message_tree= // one "news_message_tree" (recursive)
                              Class(c_basic_object)
                                // -- m_name: the key (to find the children)
                                m_c_parent_news_thread_list: c_news_thread_list;

                                // -- the payload
                                m_c_news_message_ref: c_news_message;
                                m_c_news_message_child_list: tStringList;

                                Constructor create_news_message_tree(p_name: String;
                                    p_c_parent_news_thread_list: c_news_thread_list;
                                    p_c_news_message_ref: c_news_message);

                                function f_display_news_message_tree: String;
                                function f_c_self: c_news_message_tree;

                                function f_news_message_child_count: Integer;
                                function f_c_news_message_child(p_news_message_index: Integer): c_news_message_tree;
                                function f_index_of_news_message_child(p_news_message_name: String): Integer;
                                function f_c_find_by_news_message_child(p_news_message_name: String): c_news_message_tree;

                                procedure display_news_message_child_list;

                                procedure add_news_message_child(p_c_news_message_tree: c_news_message_tree);

                                Destructor Destroy; Override;
                              end; // c_news_message_tree

         c_news_thread= // one thread= serveral messages
                        Class(c_basic_object)
                          // -- m_name: the thread title (the topic)
                          m_c_parent_news_thread_list: c_news_thread_list;

                          // -- the linear structure
                          m_c_news_message_list: tStringList;

                          // -- the message tree
                          m_c_root_news_message: c_news_message_tree;
                          // -- the root of the thread was not retrieved (too old)
                          m_has_root_message: Boolean;
                          m_date_min, m_date_max: tDateTime;

                          Constructor create_news_thread(p_name: String;
                              p_c_parent_news_thread_list: c_news_thread_list);
                          function f_display_news_thread: String;
                          function f_c_self: c_news_thread;

                          // -- the linear structure
                          function f_news_message_count: Integer;
                          function f_c_news_message(p_news_message_index: Integer): c_news_message;
                          function f_index_of(p_news_message_name: String): Integer;
                          function f_c_find_by_news_message(p_news_message_name: String): c_news_message;
                          procedure add_news_message(p_news_message_name: String; p_c_news_message: c_news_message);
                          function f_c_add_news_message(p_news_message_name: String): c_news_message;
                          procedure display_news_message_list;

                          procedure update_date_min_max(p_c_news_message: c_news_message);

                          // -- add to the tree
                          function f_c_find_in_tree(p_key: String): c_news_message_tree;
                          procedure add_news_thread_message_to_tree(p_c_news_message: c_news_message;
                              p_header_for_debug: String);
                          procedure fill_treeview(p_c_treeview_ref: tTreeView);

                          Destructor Destroy; Override;
                        end; // c_news_message_list

         c_news_thread_list= // "news_thread" list
                             Class(c_basic_object)
                               m_c_news_thread_list: tStringList;
                               m_do_build_tree: Boolean;
                               m_trace_news_messages: Boolean;

                               m_c_error_log_ref: c_log;
                               _m_error_newsgroup_name: String;
                               m_error_count: Integer;

                               Constructor create_news_thread_list(p_name: String);

                               procedure trace_news_messages(p_text: String);
                               procedure log_error(p_error: String);

                               function f_news_thread_count: Integer;
                               function f_c_news_thread(p_news_thread_index: Integer): c_news_thread;
                               function f_index_of(p_news_thread_name: String): Integer;
                               function f_c_find_by_news_thread(p_news_thread_name: String): c_news_thread;
                               procedure add_news_thread(p_news_thread_name: String; p_c_news_thread: c_news_thread);
                               function f_c_add_news_thread(p_news_thread_name: String): c_news_thread;

                               procedure display_news_thread_list;
                               procedure display_news_thread(p_thread_title: String; p_tree_or_list: Boolean);
                               procedure list_thread_and_messages;

                               procedure load_from_file(p_full_file_name: String);
                               procedure fill_thread_strings(p_c_strings: tStrings);
                               procedure fill_threads_listview(p_c_threads_listview: tListView);

                               Destructor Destroy; Override;
                             end; // c_news_thread_list

  implementation
    uses SysUtils, Math, u_c_display, u_types_constants, u_characters
        , u_strings, u_dates;

    // -- c_news_message

    Constructor c_news_message.create_news_message(p_name: String;
          p_c_parent_news_thread_list: c_news_thread_list);
      begin
        Inherited create_basic_object(p_name);

        m_c_parent_news_thread_list:= p_c_parent_news_thread_list;

        m_c_key_list:= tStringList.Create;
      end; // create_news_message

    function c_news_message.f_display_news_message: String;
      begin
        Result:= Format('%-10s ', [m_name])+ ' '+ m_id+ ' '+ m_key;
      end; // f_display_news_message

    function c_news_message.f_c_self: c_news_message;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_news_message.Destroy;
      begin
        m_c_key_list.Free;

        InHerited;
      end; // Destroy

    // -- c_news_message_tree

    Constructor c_news_message_tree.create_news_message_tree(p_name: String;
        p_c_parent_news_thread_list: c_news_thread_list;
        p_c_news_message_ref: c_news_message);
      begin
        Inherited create_basic_object(p_name);

        m_c_parent_news_thread_list:= p_c_parent_news_thread_list;
        m_c_news_message_ref:= p_c_news_message_ref;

        m_c_news_message_child_list:= tStringList.Create;
      end; // create_news_message_tree

    function c_news_message_tree.f_display_news_message_tree: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_news_message_tree

    function c_news_message_tree.f_c_self: c_news_message_tree;
      begin
        Result:= Self;
      end; // f_c_self

    function c_news_message_tree.f_news_message_child_count: Integer;
      begin
        Result:= m_c_news_message_child_list.Count;
      end; // f_news_message_child_count

    function c_news_message_tree.f_c_news_message_child(p_news_message_index: Integer): c_news_message_tree;
      begin
        Result:= c_news_message_tree(m_c_news_message_child_list.Objects[p_news_message_index]);
      end; //  f_c_news_message_child

    function c_news_message_tree.f_index_of_news_message_child(p_news_message_name: String): Integer;
      begin
        Result:= m_c_news_message_child_list.IndexOf(p_news_message_name);
      end; // f_index_of_news_message_tree

    function c_news_message_tree.f_c_find_by_news_message_child(p_news_message_name: String): c_news_message_tree;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of_news_message_child(p_news_message_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_news_message_tree(m_c_news_message_child_list.Objects[l_index_of]);
      end; // f_c_find_by_news_message_child

    procedure c_news_message_tree.add_news_message_child(p_c_news_message_tree: c_news_message_tree);
        // -- insert a new message in one of the children
        // --   the tStringList contains the key (for later search)
      begin
        m_c_news_message_child_list.AddObject(p_c_news_message_tree.m_name, p_c_news_message_tree);
      end; // add_news_message_child

    procedure c_news_message_tree.display_news_message_child_list;

      procedure display_recursive(p_level: Integer; p_c_news_message: c_news_message_tree);
        var l_news_message_index: Integer;
        begin
          with p_c_news_message do
          begin
            // display(m_name+ ' cnt= '+ IntToStr(f_news_message_count));
            if m_c_news_message_ref= Nil
              then display(f_spaces(2+ p_level* 2)+ 'bogus')
              else
                with m_c_news_message_ref do
                  display(f_spaces(2+ p_level* 2)+ m_user_name_and_e_mail+ ' ['+ m_id+ ']');

            for l_news_message_index:= 0 to f_news_message_child_count- 1 do
              display_recursive(p_level+ 1, f_c_news_message_child(l_news_message_index));
          end; // with p_c_news_message
        end; // display_recursive

      begin // display_news_message_child_list
        display_recursive(0, Self);
      end; // display_news_message_child_list

    Destructor c_news_message_tree.Destroy;
      // var l_news_message_index: Integer;
      begin
        // -- todo
(*
        // -- only free the "bogus" nodes
        for l_news_message_index:= 0 to f_news_message_child_count- 1 do
          with f_c_news_message_child(l_news_message_index) do
            if m_name= 'bogus'
              then Free;
*)
        m_c_news_message_child_list.Free;

        InHerited;
      end; // Destroy

    // -- c_news_thread

    Constructor c_news_thread.create_news_thread(p_name: String;
        p_c_parent_news_thread_list: c_news_thread_list);
      begin
        Inherited create_basic_object(p_name);

        m_c_parent_news_thread_list:= p_c_parent_news_thread_list;

        m_c_news_message_list:= tStringList.Create;
        m_date_min:= -1;
      end; // create_news_message_line

    function c_news_thread.f_display_news_thread: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_news_thread

    function c_news_thread.f_c_self: c_news_thread;
      begin
        Result:= Self;
      end; // f_c_self

    // --  the linear structure

    function c_news_thread.f_news_message_count: Integer;
      begin
        Result:= m_c_news_message_list.Count;
      end; // f_news_message_count

    function c_news_thread.f_c_news_message(p_news_message_index: Integer): c_news_message;
      begin
        Result:= c_news_message(m_c_news_message_list.Objects[p_news_message_index]);
      end; //  f_c_news_message

    function c_news_thread.f_index_of(p_news_message_name: String): Integer;
      begin
        Result:= m_c_news_message_list.IndexOf(p_news_message_name);
      end; // f_index_of

    function c_news_thread.f_c_find_by_news_message(p_news_message_name: String): c_news_message;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_news_message_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_news_message(m_c_news_message_list.Objects[l_index_of]);
      end; // f_c_find_by_name

    procedure c_news_thread.update_date_min_max(p_c_news_message: c_news_message);
        // -- "Thu, 30 Nov 2006 11:46:33 -0500"
      var l_date_string: String;
          l_index: Integer;
          l_day_of_week, l_day_string, l_month_string, l_year_string: String;
          l_datetime: tDateTime;
          l_day, l_month, l_error: Integer;  // l_year,
      begin
        l_date_string:= p_c_news_message.m_date;
        l_index:= 1;
        l_day_of_week:= f_string_extract_non_blank(l_date_string, l_index);
        if f_end_is_equal_to(l_day_of_week, ',')
          then l_day_string:= f_string_extract_non_blank(l_date_string, l_index)
          else l_day_string:= l_day_of_week;
        Val(l_day_string, l_day, l_error);
        if l_error> 0
          then l_month_string:= l_day_string
          else l_month_string:= f_string_extract_non_blank(l_date_string, l_index);

        l_month:= f_us_month_to_integer(l_month_string);
        if l_month= 0
          then
          else begin
              l_year_string:= f_string_extract_non_blank(l_date_string, l_index);

              // display('date '+ l_date_string+ ' = '+ l_day_string+ ' '+ l_month_string+ ' '+ l_year_string);

              try
                l_datetime:= EncodeDate(StrToInt(l_year_string), l_month, StrToInt(l_day_string));
                if m_date_min= -1
                  then m_date_min:= l_datetime
                  else m_date_min:= Min(m_date_min, l_datetime);
                m_date_max:= Max(m_date_max, l_datetime);
              except
                // display('date '+ l_day_string+ ' '+ l_month_string+ ' '+ l_year_string);
              end;
            end;
      end; // update_date_min_max

    procedure c_news_thread.add_news_message(p_news_message_name: String; p_c_news_message: c_news_message);
      begin
        update_date_min_max(p_c_news_message);
        m_c_news_message_list.AddObject(p_news_message_name, p_c_news_message);
      end; // add_news_message

    function c_news_thread.f_c_add_news_message(p_news_message_name: String): c_news_message;
      begin
        Result:= c_news_message.create_news_message(p_news_message_name, m_c_parent_news_thread_list);

        add_news_message(p_news_message_name, Result);
      end; // f_c_add_news_message

    procedure c_news_thread.display_news_message_list;
      var l_news_message_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_news_message_count));

        for l_news_message_index:= 0 to f_news_message_count- 1 do
          display(f_c_news_message(l_news_message_index).f_display_news_message);
      end; // display_news_message_list

    // --  the tree

    function c_news_thread.f_c_find_in_tree(p_key: String): c_news_message_tree;

      procedure find_in_tree_recursive(p_c_news_message_tree: c_news_message_tree);
        var l_child_index: Integer;
        begin
          if p_c_news_message_tree= Nil
            then
            else
              with p_c_news_message_tree do
              begin
                if m_name= p_key
                  then begin
                      Result:= f_c_self;
                      Exit;
                    end;
                for l_child_index:= 0 to f_news_message_child_count- 1 do
                  find_in_tree_recursive(f_c_news_message_child(l_child_index));
              end;
        end; // find_in_tree_recursive

      begin // f_c_find_in_tree
        Result:= Nil;
        find_in_tree_recursive(m_c_root_news_message);
      end; // f_c_find_in_tree

    procedure c_news_thread.add_news_thread_message_to_tree(p_c_news_message: c_news_message;
        p_header_for_debug: String);
        // -- add a message to the tree
        // --   the message itself has been created, but not its tree access structure

      procedure append_leaf_message(p_c_parent_news_message_tree: c_news_message_tree);
        var l_new_news_message_key: String;
            l_c_new_news_message_tree: c_news_message_tree;
        begin
          l_new_news_message_key:= p_c_news_message.m_c_key_list[0];
          m_c_parent_news_thread_list.trace_news_messages('    create_leaf '+ l_new_news_message_key);
          m_c_parent_news_thread_list.trace_news_messages('      after '+ p_c_parent_news_message_tree.m_name);
          l_c_new_news_message_tree:= c_news_message_tree.create_news_message_tree(l_new_news_message_key,
              m_c_parent_news_thread_list, p_c_news_message);
          p_c_parent_news_message_tree.add_news_message_child(l_c_new_news_message_tree);
        end; // append_leaf_message

      procedure create_initial_branch;
          // -- no root, and already keys => create a bogus tree
        var l_key_index: Integer;
            l_c_parent_news_message_tree, l_c_intermediate_news_message_tree: c_news_message_tree;
        begin
          with p_c_news_message.m_c_key_list do
          begin
            m_c_parent_news_thread_list.trace_news_messages('    create_bogus_initial_branch');
            // -- the (empty) root
            m_c_root_news_message:= c_news_message_tree.create_news_message_tree(Strings[1],
                m_c_parent_news_thread_list, Nil);
            l_c_parent_news_message_tree:= m_c_root_news_message;

            // -- now the branch of the intermediates
            for l_key_index:= 2 to Count- 1 do
            begin
              l_c_intermediate_news_message_tree:= c_news_message_tree.create_news_message_tree(Strings[l_key_index],
                  m_c_parent_news_thread_list, Nil);
              l_c_parent_news_message_tree.add_news_message_child(l_c_intermediate_news_message_tree);
              l_c_parent_news_message_tree:= l_c_intermediate_news_message_tree;
            end;
          end; // with p_c_news_message

          // -- finally append the node itself
          append_leaf_message(l_c_parent_news_message_tree);
          // m_c_root_news_message.display_news_message_child_list;
        end; // create_initial_branch

      procedure add_broken_message;
          // -- we do not have the first message. Could start in the middle of many answers
          // --  => if finds an ancestor, ok, else create bogus branches
        var l_key_index: Integer;
            l_key: String;
            l_c_parent_news_message_tree, l_c_child_news_message_tree: c_news_message_tree;
            l_intermediate_key_index: Integer;
            l_c_intermediate_news_message_tree: c_news_message_tree;
        begin
          m_c_parent_news_thread_list.trace_news_messages('  broken_intermediate '
              + p_c_news_message.m_user_name_and_e_mail+ ' '+ IntToStr(p_c_news_message.m_c_key_list.Count));

          if p_c_news_message.m_c_key_list.Count<= 1
            then begin
                // -- some non-root messages have no link to any prior message, whatsoever
                m_c_parent_news_thread_list.log_error('non_root_without_ref '+ p_c_news_message.f_display_news_message);
                Inc(m_c_parent_news_thread_list.m_error_count);
                append_leaf_message(m_c_root_news_message);
                Exit;
              end;

          // -- Try to locate the [1] value
          l_key:= p_c_news_message.m_c_key_list[1];
          l_c_parent_news_message_tree:= f_c_find_in_tree(l_key);
          if l_c_parent_news_message_tree= Nil
            then begin
                // -- could not locate this key anywhere
                // --   create the branch
                create_initial_branch;
                // -- the starting point is the new root
                l_c_parent_news_message_tree:= m_c_root_news_message;
              end;

          // -- now, starting from the initial root, try to find the longest parent
          l_key_index:= 2;
          while l_key_index<= p_c_news_message.m_c_key_list.Count- 1 do
          begin
            l_key:= p_c_news_message.m_c_key_list[l_key_index];
            m_c_parent_news_thread_list.trace_news_messages('    ref '+ l_key);
            l_c_child_news_message_tree:= l_c_parent_news_message_tree.f_c_find_by_news_message_child(l_key);
            if l_c_child_news_message_tree= Nil
              then Break
              else l_c_parent_news_message_tree:= l_c_child_news_message_tree;
            Inc(l_key_index);
          end; // while l_key_index

          // -- if did not reach the end, create a bogus branch from the parent to the node
          for l_intermediate_key_index:= l_key_index to p_c_news_message.m_c_key_list.Count- 1 do
          begin
            l_key:= p_c_news_message.m_c_key_list[l_intermediate_key_index];
            l_c_intermediate_news_message_tree:= c_news_message_tree.create_news_message_tree(l_key,
                m_c_parent_news_thread_list, Nil);
            l_c_parent_news_message_tree.add_news_message_child(l_c_intermediate_news_message_tree);
            l_c_parent_news_message_tree:= l_c_intermediate_news_message_tree;
          end;

          // -- finally append the node itself
          append_leaf_message(l_c_parent_news_message_tree);
        end; // add_broken_message

      procedure add_the_message;
        var l_key_index: Integer;
            l_key: String;
            l_c_parent_news_message_tree, l_c_child_news_message_tree: c_news_message_tree;
        begin
          m_c_parent_news_thread_list.trace_news_messages('  intermediate '
              + p_c_news_message.m_user_name_and_e_mail+ ' '+ IntToStr(p_c_news_message.m_c_key_list.Count));

          if p_c_news_message.m_c_key_list.Count<= 1
            then begin
                // -- some non-root messages have no link to any prior message, whatsoever
                m_c_parent_news_thread_list.log_error('non_root_without_ref '+ p_c_news_message.f_display_news_message);
                Inc(m_c_parent_news_thread_list.m_error_count);
                append_leaf_message(m_c_root_news_message);
                Exit;
              end;

          // -- normally [1] is the root. In some cases this is not the case
          // --  => has to locate the [1] value
          l_key:= p_c_news_message.m_c_key_list[1];
          l_c_parent_news_message_tree:= f_c_find_in_tree(l_key);
          if l_c_parent_news_message_tree= Nil
            then begin
                // display_bug_stop('parent_ref_not_found '+ l_key);
                m_c_parent_news_thread_list.log_error('parent_ref_not_found '+ l_key);
                Inc(m_c_parent_news_thread_list.m_error_count);
                // -- the first key is nowhere in the tree
                // --  => create a bogus branch (even if [2] is the root or whatever
                add_broken_message;
                Exit;
              end;

          l_key_index:= 2;
          while l_key_index<= p_c_news_message.m_c_key_list.Count- 1 do
          begin
            l_key:= p_c_news_message.m_c_key_list[l_key_index];
            m_c_parent_news_thread_list.trace_news_messages('    ref '+ l_key);
            l_c_child_news_message_tree:= l_c_parent_news_message_tree.f_c_find_by_news_message_child(l_key);
            if l_c_child_news_message_tree= Nil
              then begin
(*
                  display(p_header_for_debug);
                  display_strings_only(m_c_news_message_list);
                  display_news_message_list;
                  display_strings('', p_c_news_message.m_c_key_list);
*)
                  m_c_parent_news_thread_list.log_error('not_found_'+ l_key+ ' at_ix '+ IntToStr(l_key_index));
                  Inc(m_c_parent_news_thread_list.m_error_count);
                  // -- a key in the list was not found
                  // --   => try to patch the chain with a bogus entry
                end
              else l_c_parent_news_message_tree:= l_c_child_news_message_tree;

            Inc(l_key_index);
          end; // while l_key_index

          // -- finally append the node itself
          append_leaf_message(l_c_parent_news_message_tree);
        end; // add_the_message

      begin // add_news_thread_message_to_tree
        m_c_parent_news_thread_list.trace_news_messages(m_name);

        if m_c_root_news_message= Nil
          then begin
              // -- this is the first message with this topic

              // -- if the key list contains several items (not the first), build a bogus tree
              if p_c_news_message.m_c_key_list.Count> 1
                then begin
                    // -- sanity
                    if not p_c_news_message.m_is_first_in_thread // not m_is_broken
                      then display('*** not_first_message');
                    create_initial_branch;
                  end
                else begin
                    m_c_parent_news_thread_list.trace_news_messages('  root_nil 1_ref '+ m_name); // p_c_news_message.m_user_name_and_e_mail);

                    m_c_root_news_message:= c_news_message_tree.create_news_message_tree(p_c_news_message.m_c_key_list[0],
                        m_c_parent_news_thread_list, p_c_news_message);
                  end;
            end
          else begin
              // -- the tree has already been initialized (could be a broken tree)
              // --   Insert the message in this tree
              if not m_has_root_message
                then add_broken_message
                else // add_the_message_recursive(m_c_root_news_message, 1);
                     add_the_message;
            end;
      end; // add_news_thread_message_to_tree

    Destructor c_news_thread.Destroy;
      var l_news_message_index: Integer;
      begin
        for l_news_message_index:= 0 to f_news_message_count- 1 do
          f_c_news_message(l_news_message_index).Free;
        m_c_news_message_list.Free;

        Inherited;
      end; // Destroy

    // -- c_news_thread_list

    Constructor c_news_thread_list.create_news_thread_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        _m_error_newsgroup_name:= p_name;
        m_c_news_thread_list:= tStringList.Create;
        if p_name= 'broken'
          then Exit;
      end; // create_news_thread_line

    procedure c_news_thread_list.trace_news_messages(p_text: String);
      begin
        if m_trace_news_messages
          then display(p_text);
      end; // trace_news_messages

    procedure c_news_thread_list.log_error(p_error: String);
      begin
        if m_c_error_log_ref<> Nil
          then
            with m_c_error_log_ref do
            begin
              // -- do not display twice
              if _m_error_newsgroup_name<> ''
                then begin
                    write_line('');
                    write_line(_m_error_newsgroup_name);
                    _m_error_newsgroup_name:= '';
                  end;
              write_line('  '+ p_error);
            end; // with m_c_error_log
      end; // log_error

    function c_news_thread_list.f_news_thread_count: Integer;
      begin
        Result:= m_c_news_thread_list.Count;
      end; // f_news_thread_count

    function c_news_thread_list.f_c_news_thread(p_news_thread_index: Integer): c_news_thread;
      begin
        Result:= c_news_thread(m_c_news_thread_list.Objects[p_news_thread_index]);
      end; //  f_c_news_thread

    function c_news_thread_list.f_index_of(p_news_thread_name: String): Integer;
      begin
        Result:= m_c_news_thread_list.IndexOf(p_news_thread_name);
      end; // f_index_of

    function c_news_thread_list.f_c_find_by_news_thread(p_news_thread_name: String): c_news_thread;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_news_thread_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_news_thread(m_c_news_thread_list.Objects[l_index_of]);
      end; // f_c_find_by_name

    procedure c_news_thread_list.add_news_thread(p_news_thread_name: String; p_c_news_thread: c_news_thread);
      begin
        m_c_news_thread_list.AddObject(p_news_thread_name, p_c_news_thread);
      end; // add_news_thread

    function c_news_thread_list.f_c_add_news_thread(p_news_thread_name: String): c_news_thread;
      begin
        Result:= c_news_thread.create_news_thread(p_news_thread_name, Self);
        add_news_thread(p_news_thread_name, Result);
      end; // f_c_add_news_thread

    procedure c_news_thread_list.display_news_thread_list;
      var l_news_thread_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_news_thread_count));

        for l_news_thread_index:= 0 to f_news_thread_count- 1 do
          with f_c_news_thread(l_news_thread_index) do
          begin
            display(m_name);
            // m_c_root_news_message.display_news_message_list;
(*
            for l_news_message_index:= 0 to f_news_message_count- 1 do
              with f_c_news_message(l_news_message_index) do
                display('  '+ m_user_name_and_e_mail);
*)
          end;
      end; // display_news_thread_list

    procedure c_news_thread_list.display_news_thread(p_thread_title: String;
        p_tree_or_list: Boolean);
      var l_c_news_thread: c_news_thread;
          l_news_message_index: Integer;
      begin
        l_c_news_thread:= f_c_find_by_news_thread(p_thread_title);

        if l_c_news_thread<> Nil
          then
            with l_c_news_thread do
            begin
              display(m_name);

              if p_tree_or_list
                then m_c_root_news_message.display_news_message_child_list
                else
                  for l_news_message_index:= 0 to f_news_message_count- 1 do
                    with f_c_news_message(l_news_message_index) do
                    begin
(*
                      display(m_user_name_and_e_mail);
                      display('  '+ m_date);
                      display_strings('', m_c_key_list);
                      display('  '+ m_byte_count+ ' '+ m_line_count);
*)
                      display(m_user_name+ ' ['+ m_id+ ']');
                      // display('  '+ m_id+ ' '+ date);
                      display_strings(m_c_key_list);
                      // display('  '+ m_byte_count+ ' '+ m_line_count);
                    end;
            end
          else begin
              // display_bug_stop('no_>'+ p_thread_title+ '<');
              log_error('no_>'+ p_thread_title+ '<');
              Inc(m_error_count);
            end;
      end; // display_news_thread

    procedure c_news_thread_list.list_thread_and_messages;
      var l_news_thread_index, l_news_message_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_news_thread_count));

        for l_news_thread_index:= 0 to f_news_thread_count- 1 do
          with f_c_news_thread(l_news_thread_index) do
          begin
            display(m_name);

            for l_news_message_index:= 0 to f_news_message_count- 1 do
              with f_c_news_message(l_news_message_index) do
                display('  '+ m_id+ ' '+ m_user_name_and_e_mail);
          end;
      end; // list_thread_and_messages

    procedure c_news_thread_list.load_from_file(p_full_file_name: String);
      var l_list_index: Integer;
          l_the_line: String;
          l_index, l_length: Integer;

      function f_extract_until_tab: String;
        begin
          skip_blanks(l_the_line, l_index);
          Result:= Trim(f_string_extract_until(l_the_line, k_tabulation, l_index));
        end; // f_extract_until_tab

      procedure extract_keys(p_c_news_message: c_news_message);
          // -- the keys can be glued together without blanks !
          // --  => could not use f_string_extract_characters_not_in or f_string_extract_until(tab)
        var l_key: String;
        begin
          while l_index< l_length do
          begin
            skip_blanks(l_the_line, l_index);

            if (l_index<= l_length) and (l_the_line[l_index]= '<')
              then begin
                  l_key:= '';
                  while (l_index<= l_length) and (l_the_line[l_index]<> '>') do
                  begin
                    l_key:= l_key+ l_the_line[l_index];
                    Inc(l_index);
                  end; // while (l_index
                  l_key:= l_key+ '>';
                  Inc(l_index);

                  p_c_news_message.m_c_key_list.Add(l_key);
                end
              else Break;
          end; // while l_index
        end; // extract_keys

      function f_extract_until_blanks: String;
        begin
          skip_blanks(l_the_line, l_index);
          Result:= Trim(f_string_extract_characters_not_in(l_the_line, l_index, k_blanks));
        end; // f_extract_until_blanks

      function f_is_date(p_text: String): Boolean;
          // -- when the name is missing, reads the date instead
          // --   this tries to identify the date
        begin
          Result:= (Pos('2004', p_text)> 0)
              or (Pos('2005', p_text)> 0)
              or (Pos('2006', p_text)> 0)
              or (Pos('2007', p_text)> 0)
        end; // f_is_date

      var l_c_news_thread: c_news_thread;
          l_id, l_thread_name: String;
          l_name, l_date: String;
          l_c_news_message: c_news_message;
          l_is_first_in_thread: Boolean;

      begin // load_from_file
        with tStringList.Create do
        begin
          LoadFromFile(p_full_file_name);
          display('loaded '+ IntToStr(Count));

          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Trim(Strings[l_list_index]);

            l_index:= 1;
            l_length:= Length(l_the_line);

            l_id:= f_string_extract_non_blank(l_the_line, l_index);

            l_thread_name:= f_extract_until_tab;
            if (l_index> l_length)
              then begin
                  log_error('|'+ l_the_line+ '|');
                  Inc(m_error_count);
                end;

            l_is_first_in_thread:= False;
            if Copy(l_thread_name, 1, 4)= 'Re: '
              then begin
                  // -- this references a previous article in the thread
                  System.Delete(l_thread_name, 1, 4);
                  l_c_news_thread:= f_c_find_by_news_thread(l_thread_name);
                  if l_c_news_thread= Nil
                    then begin
                        // -- might be the first article in the thread
                        // --  if the download started after the thread root
                        l_c_news_thread:= f_c_add_news_thread(l_thread_name);
                        l_is_first_in_thread:= True;
                      end;
                end
              else begin
                  l_c_news_thread:= f_c_find_by_news_thread(l_thread_name);
                  // -- should NOT find a prior element
                  if l_c_news_thread= Nil
                    then begin
                        l_c_news_thread:= f_c_add_news_thread(l_thread_name);
                        l_is_first_in_thread:= True;
                      end
                    else begin
                        // -- some people do not put "Re: " at the start of an answer
                        // --   if we already found this article, just add this
                        // --   one to the existing thread
                      end;
                  // -- even if not "Re: ", could be an answer
                  // --   will toggle after key parsing
                end;

            l_name:= f_extract_until_tab;
            // -- the name/e-mail is empty
            if (Pos('<', l_name)= 0) and (Pos('@', l_name)= 0)
              then begin
                  log_error('no_e_mail '+ l_id);
                  Inc(m_error_count);
                  if f_is_date(l_name)
                    then begin
                        l_name:= '???';
                        l_date:= l_name;
                      end
                    else l_date:= f_extract_until_tab;
                end
              else l_date:= f_extract_until_tab;

            l_c_news_message:= c_news_message.create_news_message(l_id, Self);
            with l_c_news_message do
            begin
              m_id:= l_id;
              m_user_name_and_e_mail:= l_name;
              m_date:= l_date;

              extract_keys(f_c_self);
              if m_c_key_list.Count> 0
                then m_key:= m_c_key_list[0]
                else begin
                    m_c_parent_news_thread_list.log_error('no_key_0 '+ m_id);
                    Inc(m_error_count);
                    m_key:= '???';
                  end;

              m_byte_count:= f_extract_until_blanks;
              m_line_count:= f_extract_until_blanks;
              m_group_ref:= f_extract_until_blanks;

              l_index:= 1;
              m_user_name:= Trim(f_string_extract_until(m_user_name_and_e_mail, '<', l_index));
              m_user_e_mail:= Copy(m_user_name_and_e_mail, l_index, Length(m_user_name_and_e_mail)+ 1- l_index);

              m_is_first_in_thread:= l_is_first_in_thread;
              if m_is_first_in_thread
                then l_c_news_thread.m_has_root_message:= m_c_key_list.Count= 1;
            end; // with l_c_news_message

            // -- currently, this is mandatory (the tree only uses refs)
            trace_news_messages(Copy(l_the_line, 1, 50));
            l_c_news_thread.add_news_message(l_id, l_c_news_message);
            if m_do_build_tree
              then l_c_news_thread.add_news_thread_message_to_tree(l_c_news_message, l_the_line);
          end; // while l_list_index

          Free;
        end; // with tStringList
      end; // load_from_file

    procedure c_news_thread.fill_treeview(p_c_treeview_ref: tTreeView);

      function f_message(p_c_news_message_tree: c_news_message_tree): String;
        begin
          with p_c_news_message_tree do
            if m_c_news_message_ref= Nil
              then Result:= 'bogus'
              else Result:= m_c_news_message_ref.m_user_name_and_e_mail;
        end; // f_message

      procedure fill_tree_recursive(p_c_news_message_tree: c_news_message_tree;
          p_c_parent_node: tTreeNode);
        var l_news_message_index: Integer;
            l_c_child_node: tTreeNode;
        begin
          if p_c_news_message_tree<> Nil
            then
              with p_c_news_message_tree do
              begin
                for l_news_message_index:= 0 to f_news_message_child_count- 1 do
                  with f_c_news_message_child(l_news_message_index) do
                  begin
                    l_c_child_node:= p_c_treeview_ref.Items.AddChildObject(p_c_parent_node,
                        f_message(f_c_self), f_c_self.m_c_news_message_ref);

                    fill_tree_recursive(f_c_self, l_c_child_node);
                  end;
              end;
        end; // fill_tree_recursive

      var l_c_root_node: tTreeNode;

      begin // fill_treeview
        with p_c_treeview_ref do
        begin
          Items.BeginUpdate;
          Items.Clear;
          // -- fill the root
          l_c_root_node:= p_c_treeview_ref.Items.AddChildObject(nil,
              f_message(m_c_root_news_message), m_c_root_news_message.m_c_news_message_ref);
          fill_tree_recursive(m_c_root_news_message, l_c_root_node);
          FullExpand;
          Items.EndUpdate;
        end; // with p_c_treeview_ref
      end; // fill_treeview

    procedure c_news_thread_list.fill_thread_strings(p_c_strings: tStrings);
      var l_news_thread_index: Integer;
      begin
        p_c_strings.Clear;
        for l_news_thread_index:= 0 to f_news_thread_count- 1 do
          with f_c_news_thread(l_news_thread_index) do
            p_c_strings.AddObject(m_name, f_c_self);
      end; // fill_thread_strings

    procedure c_news_thread_list.fill_threads_listview(p_c_threads_listview: tListView);
      var l_news_thread_index: Integer;
          l_c_item: TListItem;
      begin
        with p_c_threads_listview.Items do
        begin
          BeginUpdate;

          for l_news_thread_index:= 0 to f_news_thread_count- 1 do
            with f_c_news_thread(l_news_thread_index) do
            begin
              l_c_item:= Add;
              with l_c_item do
              begin
                Data:= Pointer(f_c_self);
                Caption:= m_name;
                SubItems.Add(FormatDateTime('mm-yy', m_date_min));
              end; // with l_c_item
            end; // with f_c_news_thread

          EndUpdate;
        end; // with p_c_threads_listview.Items
      end; // fill_threads_listview

    Destructor c_news_thread_list.Destroy;
      var l_news_thread_index: Integer;
      begin
        for l_news_thread_index:= 0 to f_news_thread_count- 1 do
          f_c_news_thread(l_news_thread_index).Free;
        m_c_news_thread_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_news_thread_list
    end. // u_c_news_thread_list

